#include <SPI.h>

//UNO R3 SPI Pins
int chipSelectPin = 10;// SS 10
int COPIpin = 11;// COPI (MOSI) 11
int CIPOpin = 12;// CIPO (MISO) 12
int Clockpin = 13;// SCK 13

void setup() {
\
  Serial.begin(9600); // start serial for output

  // Initialize chip select pin
  pinMode(chipSelectPin, OUTPUT);
  pinMode(COPIpin, OUTPUT);
  pinMode(CIPOpin, INPUT);
  pinMode(Clockpin, OUTPUT);

  digitalWrite(chipSelectPin, HIGH);  // Set CS high initially
  delay(1);

  SPI.begin(); //Initializes the SPI bus by setting SCK, MOSI, and SS to outputs, pulling SCK and MOSI low, and SS high.
  SPI.beginTransaction(SPISettings(100000, MSBFIRST, SPI_MODE0));

  //Writing register exactly as done on EVM code provided
  writeRegister(1, 1);
  writeRegister(0, 0);
  writeRegister(200, 2);
  writeRegister(200, 130);
  writeRegister(203, 2048);
  writeRegister(203, 26624);
  writeRegister(200, 386);
  writeRegister(193, 64);
  writeRegister(194, 1);
  writeRegister(191, 16);
  writeRegister(200, 655746);
  writeRegister(201, 512);
  writeRegister(10, 74);
  writeRegister(10, 8388674);
  writeRegister(10, 9437418);
  writeRegister(10, 9695762);
  writeRegister(12, 5179408);
  writeRegister(75, 256);
  writeRegister(29, 8388608);
  writeRegister(29, 12582912);
  writeRegister(0, 65);
  writeRegister(0, 64);
  writeRegister(206, 16);
  writeRegister(66, 32);
  writeRegister(41, 524288);
  writeRegister(66, 524320);
  writeRegister(187, 2);
  writeRegister(187, 6);
  writeRegister(187, 14);
  writeRegister(187, 30);
  writeRegister(187, 62);
  writeRegister(218, 1);
  writeRegister(219, 2048);
  writeRegister(219, 2560);
  writeRegister(219, 2816);
  writeRegister(221, 1006308);
  writeRegister(222, 1048768);
  writeRegister(117, 524288);
  writeRegister(220, 4);
  writeRegister(220, 8644);
  writeRegister(220, 25060);
  writeRegister(220, 282308);
  writeRegister(218, 17);
  writeRegister(218, 1041);
  writeRegister(190, 4);
  writeRegister(190, 5);
  writeRegister(190, 7);
  writeRegister(214, 1638412);
  writeRegister(214, 1638668);
  writeRegister(1, 0);
  writeRegister(29, 0);
  writeRegister(0, 2);
  writeRegister(0, 64);
  writeRegister(29, 12582912);
  writeRegister(0, 65);

}
void loop() {

  readRegister(0x6D);
  delay(1);

  Serial.println(readRegister(0xFF));
  delay(1);

  readRegister(0xBC);
  delay(100);

}

// Function to write to a register
void writeRegister(uint8_t reg, uint32_t value) {
  digitalWrite(chipSelectPin, LOW);
  SPI.transfer(reg);                 // Register address
  SPI.transfer((value >> 16) & 0xFF); // Data byte 2 (MSB)
  SPI.transfer((value >> 8) & 0xFF);  // Data byte 1
  SPI.transfer(value & 0xFF);         // Data byte 0 (LSB)
  digitalWrite(chipSelectPin, HIGH);
  delay(1);
}

// Function to read from a register
uint32_t readRegister(uint8_t reg) {
  uint32_t byte1 = 0;
  uint32_t byte2 = 0;
  uint32_t byte3 = 0;

  digitalWrite(chipSelectPin, LOW);
  SPI.transfer(reg);  // Register address with read command
  byte1 = SPI.transfer(0);  // Read byte 2 (MSB)
  byte2 = SPI.transfer(0);   // Read byte 1
  byte3 = SPI.transfer(0);        // Read byte 0 (LSB)
  digitalWrite(chipSelectPin, HIGH);
  delay(1);

  // Concatenate the bytes
  uint32_t combinedValue = (byte1 << 16) | (byte2 << 8) | byte3;
  return combinedValue;
}

